import _classPrivateMethodInitSpec from "@babel/runtime-corejs3/helpers/classPrivateMethodInitSpec";
import _classPrivateFieldInitSpec from "@babel/runtime-corejs3/helpers/classPrivateFieldInitSpec";
import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _WeakMap from "@babel/runtime-corejs3/core-js-stable/weak-map";
import _WeakSet from "@babel/runtime-corejs3/core-js-stable/weak-set";
function _classPrivateFieldGet(s, a) { return s.get(_assertClassBrand(s, a)); }
function _classPrivateFieldSet(s, a, r) { return s.set(_assertClassBrand(s, a), r), r; }
function _assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }
import { isReactive, isRef } from 'vue';
class ReactiveWebStorageError extends Error {}
var _reactiveStorage = new _WeakMap();
var _ReactiveStorageAdapter_brand = new _WeakSet();
class ReactiveStorageAdapter {
  constructor(_reactiveStorage2) {
    _classPrivateMethodInitSpec(this, _ReactiveStorageAdapter_brand);
    _classPrivateFieldInitSpec(this, _reactiveStorage, void 0);
    if (!_reactiveStorage2 || !isReactive(_reactiveStorage2) && !isRef(_reactiveStorage2)) {
      throw new ReactiveWebStorageError('"reactiveStorage" object must be a reactive or ref object');
    }
    _classPrivateFieldSet(_reactiveStorage, this, _reactiveStorage2);
  }
  get reactiveStorage() {
    return _classPrivateFieldGet(_reactiveStorage, this);
  }
  get length() {
    var reactiveStorage = _assertClassBrand(_ReactiveStorageAdapter_brand, this, _obtainReactiveStorageValue).call(this);
    return _Object$keys(reactiveStorage).length;
  }
  key(index) {
    var _Object$keys$index;
    var reactiveStorage = _assertClassBrand(_ReactiveStorageAdapter_brand, this, _obtainReactiveStorageValue).call(this);
    return (_Object$keys$index = _Object$keys(reactiveStorage)[index]) !== null && _Object$keys$index !== void 0 ? _Object$keys$index : null;
  }
  setItem(key, item) {
    var reactiveStorage = _assertClassBrand(_ReactiveStorageAdapter_brand, this, _obtainReactiveStorageValue).call(this);
    reactiveStorage[key] = item;
  }
  getItem(key) {
    var _reactiveStorage$key;
    var reactiveStorage = _assertClassBrand(_ReactiveStorageAdapter_brand, this, _obtainReactiveStorageValue).call(this);
    return (_reactiveStorage$key = reactiveStorage[key]) !== null && _reactiveStorage$key !== void 0 ? _reactiveStorage$key : null;
  }
  removeItem(key) {
    var reactiveStorage = _assertClassBrand(_ReactiveStorageAdapter_brand, this, _obtainReactiveStorageValue).call(this);
    if (Object.hasOwn(reactiveStorage, key)) {
      delete reactiveStorage[key];
    }
  }
  clear() {
    var reactiveStorage = _assertClassBrand(_ReactiveStorageAdapter_brand, this, _obtainReactiveStorageValue).call(this);
    for (var key in reactiveStorage) {
      this.removeItem(key);
    }
  }
}
function _obtainReactiveStorageValue() {
  var reactiveStorage = _classPrivateFieldGet(_reactiveStorage, this);
  return isRef(reactiveStorage) ? reactiveStorage.value : reactiveStorage;
}
var _prefix = new _WeakMap();
var _webStorage = new _WeakMap();
var _reactiveStorageAdapter = new _WeakMap();
var _ReactiveWebStorage_brand = new _WeakSet();
class ReactiveWebStorage {
  constructor(_prefix2, webStorage, reactiveStorageAdapter) {
    _classPrivateMethodInitSpec(this, _ReactiveWebStorage_brand);
    _classPrivateFieldInitSpec(this, _prefix, void 0);
    _classPrivateFieldInitSpec(this, _webStorage, void 0);
    _classPrivateFieldInitSpec(this, _reactiveStorageAdapter, void 0);
    if (!webStorage || !(webStorage instanceof Storage)) {
      throw new ReactiveWebStorageError('The "webStorage" object must implement the Storage interface');
    }
    _classPrivateFieldSet(_prefix, this, _prefix2);
    _classPrivateFieldSet(_webStorage, this, webStorage);
    _classPrivateFieldSet(_reactiveStorageAdapter, this, reactiveStorageAdapter);
  }
  obtainWebStorageKey(key) {
    var _context;
    return _classPrivateFieldGet(_prefix, this) !== '' ? _concatInstanceProperty(_context = "".concat(_classPrivateFieldGet(_prefix, this), "-")).call(_context, key) : key;
  }
  obtainReactiveStorageAdapterKey(key) {
    var keyElements = key.split('-');
    return keyElements[keyElements - 1];
  }
  get reactiveStorageAdapter() {
    return _classPrivateFieldGet(_reactiveStorageAdapter, this);
  }
  get reactiveStorage() {
    return _classPrivateFieldGet(_reactiveStorageAdapter, this).reactiveStorage;
  }
  get prefix() {
    return _classPrivateFieldGet(_prefix, this);
  }
  get length() {
    return _classPrivateFieldGet(_reactiveStorageAdapter, this).length;
  }
  key(index) {
    return _classPrivateFieldGet(_reactiveStorageAdapter, this).key(index);
  }
  getItem(key) {
    var value = _classPrivateFieldGet(_reactiveStorageAdapter, this).getItem(key);
    if (!value) {
      var webStorageKey = this.obtainWebStorageKey(key);
      value = _classPrivateFieldGet(_webStorage, this).getItem(webStorageKey);
      if (value) {
        _classPrivateFieldGet(_reactiveStorageAdapter, this).setItem(key, value);
      }
    }
    return value;
  }
  setItem(key, item) {
    try {
      var webStorageKey = this.obtainWebStorageKey(key);
      _classPrivateFieldGet(_webStorage, this).setItem(webStorageKey, item);
      _classPrivateFieldGet(_reactiveStorageAdapter, this).setItem(key, item);
    } catch (err) {
      throw new ReactiveWebStorageError(err.message, {
        cause: err
      });
    }
  }
  removeItem(key) {
    var webStorageKey = this.obtainWebStorageKey(key);
    _classPrivateFieldGet(_webStorage, this).removeItem(webStorageKey);
    _classPrivateFieldGet(_reactiveStorageAdapter, this).removeItem(key);
  }
  clear() {
    var length = _classPrivateFieldGet(_reactiveStorageAdapter, this).length;
    for (var i = 0; i < length; i++) {
      var key = _classPrivateFieldGet(_reactiveStorageAdapter, this).key(i);
      var webStorageKey = this.obtainWebStorageKey(key);
      _classPrivateFieldGet(_webStorage, this).removeItem(webStorageKey);
    }
    _classPrivateFieldGet(_reactiveStorageAdapter, this).clear();
  }
  loadDataFromWebStorage() {
    var length = _classPrivateFieldGet(_webStorage, this).length;
    for (var index = 0; index < length; ++index) {
      var webStorageKey = _classPrivateFieldGet(_webStorage, this).key(index);
      if (_assertClassBrand(_ReactiveWebStorage_brand, this, _isWebStorageKey).call(this, webStorageKey)) {
        var value = _classPrivateFieldGet(_webStorage, this).getItem(webStorageKey);
        var reactiveStorageAdapterKey = this.obtainReactiveStorageAdapterKey(webStorageKey);
        _classPrivateFieldGet(_reactiveStorageAdapter, this).setItem(reactiveStorageAdapterKey, value);
      }
    }
  }
}
function _isWebStorageKey(key) {
  var keyElements = key.split('-');
  var prefix = keyElements[0];
  return prefix === _classPrivateFieldGet(_prefix, this);
}
class ReactiveWebStorageFactory {
  static createReactiveWebStorage(prefix, webStorage, reactiveStorage) {
    return new ReactiveWebStorage(prefix, webStorage, new ReactiveStorageAdapter(reactiveStorage));
  }
}
var _ReactiveWebStorageInstaller_brand = new _WeakSet();
class ReactiveWebStorageInstaller {
  constructor() {
    _classPrivateMethodInitSpec(this, _ReactiveWebStorageInstaller_brand);
  }
  install(app, options) {
    var {
      prefix = '',
      webStorage,
      reactiveStorage,
      loadDataFromWebStorage = true
    } = options;
    var reactiveWebStorage = ReactiveWebStorageFactory.createReactiveWebStorage(prefix, webStorage, reactiveStorage);
    if (loadDataFromWebStorage) {
      _assertClassBrand(_ReactiveWebStorageInstaller_brand, this, _addLoadDataFromWebStorage).call(this, window, reactiveWebStorage);
    }
    _assertClassBrand(_ReactiveWebStorageInstaller_brand, this, _addReactiveWebStorageToApp).call(this, app, reactiveWebStorage);
  }
}
function _addLoadDataFromWebStorage(window, reactiveWebStorage) {
  window.addEventListener('load', () => {
    reactiveWebStorage.loadDataFromWebStorage();
  });
}
function _addReactiveWebStorageToApp(app, reactiveWebStorage) {
  app.config.globalProperties.$reactiveWebStorage = reactiveWebStorage;
}
function createReactiveWebStorageInstaller() {
  return new ReactiveWebStorageInstaller();
}
export { createReactiveWebStorageInstaller as default };
//# sourceMappingURL=index.mjs.map
